"""
class cybercops result.
"""

class Result(object):
    class Summary(object):
        """
        This class is stores summary information on the return data. 
        """
        def __init__(self):
            self.__items    = []
            self.__error    = None
            self.__words    = None
            self.__count    = None
            self.__userid   = None
            self.__encoding = None
            self.__errormsg = None
        
        def items():
            def fget(self): return self.__items
            return locals()
        items = property(**items())
        
        def error():
            def fget(self): return self.__error
            return locals()
        error = property(**error())
        
        def words():
            def fget(self): return self.__words
            return locals()
        words = property(**words())
        
        def count():
            def fget(self): return self.__count
            return locals()
        count = property(**count())
        
        def userid():
            def fget(self): return self.__userid
            return locals()
        userid = property(**userid())
        
        def encoding():
            def fget(self): return self.__encoding
            return locals()
        encoding = property(**encoding())
        
        def errormsg():
            def fget(self): return self.__errormsg
            return locals()
        errormsg = property(**errormsg())
        
        
        def is_error(self):
            return self.__error > 0 and True or False
        
        def level9(self):
            return self.__get_level(9)
        
        def level7(self):
            return self.__get_level(7)
        
        def level5(self):
            return self.__get_level(5)
        
        def __get_level(self, level):
            words = []
            for item in self.items:
                if item._Description__level is level:
                    words.append(item._Description__word)
            return words
    
    class Description(object):
        """
        This class is stores detailed information on the return data.
        """
        def __init__(self):
            self.__word  = None
            self.__level = None
            self.__count = None
        
        def word():
            doc = "property of word"
            def fget( self): return self.__word
            return locals()
        word  = property(**word())
        
        def level():
            doc = "property of level"
            def fget(self): return self.__level
            return locals()
        level = property(**level())
        
        def count():
            doc = "property of count"
            def fget(self): return self.__count
            return locals()
        count = property(**count())
        
        
if __name__ == '__main__':
    rs = Result.Summary()
    print rs.__class__
    for i in dir(rs): print i
    
    rd = Result.Description()
    print rd.__class__
    for i in dir(rd): print i

