"""
Module for CyberCops Version 3.X

"""
from _errors import Error
from _client import Client
from _connection import Connection

__all__ = ["Client", "Connection", "Error"]

__MAJOR = 1
__MINOR = 0
__TINY  = 0
__version__ = '.'.join(map(str, [__MAJOR, __MINOR, __TINY]))
__date__    = '2008-06-09'
__author__  = 'Shuntaro Ogawa <s.ogawa@galaweb.jp>'
__credit__  = 'Galaweb Inc.'


if __name__ == '__main__':
    for i in dir(): print i
